FORMAT: 1A
HOST: https://core.itistmo.edu.mx

# Core

Documentación del sistema "Core" desarrollada por el Instituto Tecnológico del Istmo.

## Introducción

Se describe un poco su función y su uso

## Consideraciones

Los métodos `DELETE` se consideran potencialmente peligrosos ya que eliminan registros de la base de datos, por tal motivo se implementaron mecanismos de seguridad como el uso de "SoftDelete"

::: note 
Para mas información sobre "SoftDelete" lea el glosario de términos.
:::

### Autenticación

::: note
El sistema de autenticación esta desarrollado con **Laravel Passport 5.6** para obtener información detallada del comportamiento favor de visitar la [documentación oficial](https://laravel.com/docs/5.6/passport).
:::

A excepción de algunos recursos la mayoría se encuentran protegidos por el sistema de autenticación Oauth2 para el consumo de la API, si usted desea utilizarlo requiere de un token valido para la realización de peticiones de forma correcta de lo contrario obtendrá el [siguiente mensaje](#respuestas-genéricas-colección-de-errores-y-notas-get-1).


# Group Autenticación

# Colección Token [/oauth/tokens]

### Lista de tokens [GET /oauth/tokens]

### Solicitar token [POST /oauth/token]

### Eliminar token [DELETE /oauth/tokens/{token_id}]

+ Parameter
    + token_id: 1 - Id del token
    
### Refrescar token [POST /oauth/token/refresh]


# Colección de Clientes [/oauth/clients]

## Lista Clientes [GET /oauth/clients]

## Nuevo Clientes [POST /oauth/clients]

## Actualizar Clientes [PUT /oauth/clients/{client_id}]

## Eliminar Clientes [DELETE /oauth/clients/{client_id}]

+ Parameter
    + client_id: 1 - Id del cliente


# Colección de Scopes [/oauth/scopes]

## Lista Clientes [GET /oauth/scopes]


# Colección de Tokens de Acceso Personal [/oauth/personal-access-tokens]

## Lista Tokens de Acceso Personal [GET /oauth/personal-access-tokens]

## Nuevo Token de Acceso Personal [POST /oauth/personal-access-tokens]

## Eliminar Token de Acceso Personal [DELETE /oauth/personal-access-tokens/{token_id}]

+ Parameter
    + token_id: 1 - Id del token
    
    
# Group Usuarios

Usuarios es un método que permite a los clientes ver los usuarios registrados en el sistema y todas sus relaciones.

Considere que la colección permite paginación de los elementos para un mejor manejo.

## Colección de usuarios [/v1/users]

### Lista todos los usuarios [GET /v1/users{?filter,sort,per_page}]

+ Parameters

	+ sort: `nombre|acs`(string, optional) - Ordenar resultados por:
		+ Default: `id|asc`
    + filter: `Computo` (string, optional) - Puede filtrar sus resultados mediante una palabra clave que este disponible en alguna de las siguientes columnas.
        + Default: null
        + Members
            + `nombre`
            + `nombre_segundo`
            + `apellido_paterno`
            + `apellido_materno`
            + `email`
            + `curp`
            + `nss`
    + per_page: `25` (integer, optional) - El máximo a retornar es `50`
		+ Default: `10`

+ Response 200 (application/json)

    
        {
            "current_page": 1,
            "data": [
                {
                    "id": 1,
                    "nombre": "Admin",
                    "nombre_segundo": "Centro",
                    "apellido_paterno": "de",
                    "apellido_materno": "Computo",
                    "fecha_nacimiento": null,
                    "foto": null,
                    "email": "admin@itisoft.com",
                    "curp": "MNBV12345667FG",
                    "nss": "12345678",
                    "new": 1,
                    "status": 1,
                    "deleted_at": null,
                    "created_at": "2018-05-10 17:37:08",
                    "updated_at": "2018-05-10 17:37:08",
                    "data": [
                        {
                            "id": 3,
                            "nombre": "Otro",
                            "descripcion": "Sin genero especificado",
                            "user_data_type_id": 1,
                            "status": 1,
                            "deleted_at": null,
                            "created_at": "2018-05-10 17:37:08",
                            "updated_at": "2018-05-10 17:37:08",
                            "pivot": {
                                "user_id": 1,
                                "user_data_id": 3,
                                "status": 1,
                                "created_at": "2018-05-10 17:37:08",
                                "updated_at": "2018-05-10 17:37:08"
                            },
                            "type": {
                                "id": 1,
                                "nombre": "Genero",
                                "descripcion": "Genero del usuario",
                                "status": 1,
                                "deleted_at": null,
                                "created_at": "2018-05-10 17:37:08",
                                "updated_at": "2018-05-10 17:37:08"
                            }
                        },
                        {
                            "id": 4,
                            "nombre": "Soltero",
                            "descripcion": "El usuario es Soltero/a",
                            "user_data_type_id": 2,
                            "status": 1,
                            "deleted_at": null,
                            "created_at": "2018-05-10 17:37:08",
                            "updated_at": "2018-05-10 17:37:08",
                            "pivot": {
                                "user_id": 1,
                                "user_data_id": 4,
                                "status": 1,
                                "created_at": "2018-05-10 17:37:08",
                                "updated_at": "2018-05-10 17:37:08"
                            },
                            "type": {
                                "id": 2,
                                "nombre": "Estado Civil",
                                "descripcion": "Estado Civil asociado al usuario",
                                "status": 1,
                                "deleted_at": null,
                                "created_at": "2018-05-10 17:37:08",
                                "updated_at": "2018-05-10 17:37:08"
                            }
                        }
                    ],
                    "phones": [],
                    "providers": [],
                    "emails": [],
                    "admin": {
                        "user_id": 1,
                        "status": "El usuario no es un Administrador o no esta vinculado"
                    },
                    "student": {
                        "user_id": 1,
                        "status": "El usuario no es un Estudiante o no esta vinculado"
                    },
                    "jobs": [],
                    "addresses": []
                }
            ],
            "first_page_url": "/api/v1/users?page=1",
            "from": 1,
            "last_page": 1,
            "last_page_url": "/api/v1/users?page=1",
            "next_page_url": null,
            "path": "/api/v1/users",
            "per_page": 15,
            "prev_page_url": null,
            "to": 1,
            "total": 1
        }
    
+ Response 404 (application/json)

    
        {
            "error": "Lo sentimos, no podemos encontrar eso."
        }
    

### Un solo usuario [GET /v1/users/{id}]

+ Parameter
    + id: 1 - Id del usuario

+ Response 200 (application/json)


        {   
            "id": 1,
            "nombre": "Admin",
            "nombre_segundo": "Centro",
            "apellido_paterno": "de",
            "apellido_materno": "Computo",
            "fecha_nacimiento": null,
            "foto": null,
            "email": "admin@itisoft.com",
            "curp": "MNBV12345667FG",
            "nss": "12345678",
            "new": 1,
            "status": 1,
            "deleted_at": null,
            "created_at": "2018-05-11 00:10:14",
            "updated_at": "2018-05-11 00:10:14",
            "data": [
                {
                    "id": 3,
                    "nombre": "Otro",
                    "descripcion": "Sin genero especificado",
                    "user_data_type_id": 1,
                    "status": 1,
                    "deleted_at": null,
                    "created_at": "2018-05-11 00:10:14",
                    "updated_at": "2018-05-11 00:10:14",
                    "pivot": {
                        "user_id": 1,
                        "user_data_id": 3,
                        "status": 1,
                        "created_at": "2018-05-11 00:10:14",
                        "updated_at": "2018-05-11 00:10:14"
                    },
                    "type": {
                        "id": 1,
                        "nombre": "Genero",
                        "descripcion": "Genero del usuario",
                        "status": 1,
                        "deleted_at": null,
                        "created_at": "2018-05-11 00:10:14",
                        "updated_at": "2018-05-11 00:10:14"
                    }
                },
                {
                    "id": 4,
                    "nombre": "Soltero",
                    "descripcion": "El usuario es Soltero/a",
                    "user_data_type_id": 2,
                    "status": 1,
                    "deleted_at": null,
                    "created_at": "2018-05-11 00:10:14",
                    "updated_at": "2018-05-11 00:10:14",
                    "pivot": {
                        "user_id": 1,
                        "user_data_id": 4,
                        "status": 1,
                        "created_at": "2018-05-11 00:10:14",
                        "updated_at": "2018-05-11 00:10:14"
                    },
                    "type": {
                        "id": 2,
                        "nombre": "Estado Civil",
                        "descripcion": "Estado Civil asociado al usuario",
                        "status": 1,
                        "deleted_at": null,
                        "created_at": "2018-05-11 00:10:14",
                        "updated_at": "2018-05-11 00:10:14"
                    }
                }
            ],
            "phones": [],
            "providers": [],
            "emails": [],
            "admin": {
                "user_id": 1,
                "status": "El usuario no es un Administrador o no esta vinculado"
            },
            "student": {
                "user_id": 1,
                "status": "El usuario no es un Estudiante o no esta vinculado"
            },
            "jobs": [],
            "addresses": []
        }

+ Response 404 (application/json)


        {
            "error": "Lo sentimos, no podemos encontrar eso."
        }


### Nuevo Usuario [POST /v1/users]

+ Response 404 (application/json)

    
        {
            "error": "Lo sentimos, no podemos encontrar eso."
        }
    
### Editar Usuario [PUT /v1/users/{id}]

+ Parameter
    + id: 1 - Id del usuario

+ Response 404 (application/json)


        {
            "error": "Lo sentimos, no podemos encontrar eso."
        }

### Eliminar Usuario [DELETE /v1/users/{id}]

+ Parameter
    + id: 1 - Id del usuario

+ Response 404 (application/json)


        {
            "error": "Lo sentimos, no podemos encontrar eso."
        }
        

# Estudiantes

# Group Estudiantes

Considere que la colección permite paginación de los elementos para un mejor manejo.

## Colección de estudiantes [/v1/students]

### Lista todos los estudiantes [GET /v1/students]

### Eliminar Usuario [DELETE /v1/users/{id}]

La eliminación de un estudiante se considera una acción peligrosa por tal motivo no se recomienda su uso y solo se realiza un "SoftDelete"

+ Parameter
    + id: 1 - Id del estudiante
    - token: eyJ0eI6IjYyMW...YmYyMGQzYNjBmZ - Token del cliente

# Genéricos

# Group Respuestas Genéricas

Respuestas del API  para los siguientes casos, de existir comportamientos diferentes a los mencionados podrá encontrar una nota junto al método afectado.

## Colección de errores y notas [/v1/any]

### Elemento no encontrado [GET /v1/any]

+ Response 404 (application/json)


        {
            "error": "Lo sentimos, no podemos encontrar eso."
        }

### No autorizado [GET /any]

Su token expiro o se envió en la petición, contacte con el administrador para renovar sus credenciales de acceso o solicitar una, consulte el apartado de **[Autenticación](#header-autenticación)** de este documento.

+ Response 401 (application/json)


        {
            "error": "Unauthorized."
        }

# Glosario

# Group Glosario

Lista de palabras o términos relevantes de esta documentación, si no se encuentra con la mayoría de los términos aquí expuestos considere realizar una investigación previa para poder trabajar de forma correcta con la API.

+ Response

Respuesta a la petición realizada, también se incluye el tipo de respuesta HTTP y el formato.

+ SoftDelete

Eliminación de registros en la base de datos de forma lógica o suave, es decir se marca con una bandera de tiempo y en las consultas posteriores se ignora aquellos registros que posean dicha bandera. Con ello se evita la perdida de información valiosa en sistemas críticos.

# Enlaces de interés

+ [Laravel Documentación](https://laravel.com/docs/5.6)
+ [Laravel Lumen](https://lumen.laravel.com/docs/5.6)
+ [Laravel Passport](https://laravel.com/docs/5.6/passport)
